% **********************************************************
% Financial shock (only shock to bank capital)
% zero weight output in loss function macroprudential policy
% Monetary policy only case
% **********************************************************

clear all;
clc;

randn('seed',1226);  
rand('seed',1222); 

options = optimset('TolX',1e-6,'TolFun',1e-6,'MaxIter',2000,'Display','off','MaxFunEvals',10000);

N              = 20;
initial_values = zeros(N,3);
loss_mp        = zeros(N,1);
parameters_mp  = zeros(N,3);

for nn = 1:N;
    
    disp(nn);
    
    thetstar0  = [ rand, 2+rand, rand ];
    
    initial_values(nn,:) = thetstar0;
    
    [thetstar_mp,fval,exitflag,output] = fminsearch('loss_function_mp',thetstar0,options);

    loss_MP;
    
    loss_mp(nn,1) = loss;
  
    flag_mp(nn,1) = exitflag;

    stddev_MP(nn,:) = 100.*(diag(oo_.var)).^0.5;
    
    parameters_mp(nn,:) = [ thetstar_mp ];
        
end;

save intial_conditions_mp.txt initial_values  -ASCII -DOUBLE;
save optimized_coeffs_mp.txt  parameters_mp   -ASCII -DOUBLE;
save loss_mp.txt              loss_mp         -ASCII -DOUBLE;

load optimized_coeffs_mp.txt;
load loss_mp.txt;

% extracing rule that minimizes loss function central bank

[ii,jj]  = min(loss_mp);

thetstar = optimized_coeffs_mp(jj,:);

save mp_optimized.txt thetstar -ASCII -DOUBLE;

loss_MP;



