% **********************************************************
% Financial shock (only shock to bank capital)
% zero weight output in loss function macroprudential policy
% Non-cooperative case
% **********************************************************

clear all;
clc;

randn('seed',1226);  
rand('seed',1222); 

options = optimset('TolX',1e-6,'TolFun',1e-6,'MaxIter',2000,'Display','off','MaxFunEvals',10000);

cd ..;
cd cooperative

load coop_optimized.txt;

cd ..;
cd non_cooperative

thetstar_fsp  = coop_optimized(1:2);
thetstar_mp   = coop_optimized(3:5);


thetstar_fsp_0 = thetstar_fsp;
thetstar_mp_0  = thetstar_mp;

delta_loss_fsp = 1;
delta_loss_mp  = 1;

while max(abs([delta_loss_fsp, delta_loss_mp ])) > 0.000001;
    thetstar_fsp_0                              = thetstar_fsp;
    thetstar_mp_0                               = thetstar_mp;
    
    [thetstar_fsp,fval_fsp,exitflag_fsp,output] = fminsearch('loss_function_fsp',thetstar_fsp,options,thetstar_mp);
    [thetstar_mp,fval_mp,exitflag_mp,output]    = fminsearch('loss_function_mp',thetstar_mp,options,thetstar_fsp);
    
    
    delta_loss_fsp                              = thetstar_fsp - thetstar_fsp_0;
    delta_loss_mp                               = thetstar_mp  - thetstar_mp_0;
    [ delta_loss_fsp, delta_loss_mp ]
    
end

thetstar_nc = [ thetstar_fsp, thetstar_mp ];

save optimized_coeffs_nc.txt thetstar_nc -ASCII -DOUBLE;




