% THIS VERSION 02/04/2014
% **********************************************************
% Technology shock 
% zero weight output in loss function macroprudential policy
% Cooperative case
% **********************************************************

clear all;
clc;

rand('seed',1222); 

options = optimset('TolX',1e-6,'TolFun',1e-6,'MaxIter',2000,'Display','off','MaxFunEvals',10000);

N              = 10;
initial_values = zeros(N,5);
loss_c         = zeros(N,1);
parameters_c   = zeros(N,5);

for nn = 1:N;
    
    disp(nn);
    
    thetstar0  = [ rand, 2*rand, 2*rand, 2+rand, rand ]; % draw initial conditions for parameters
    
    initial_values(nn,:) = thetstar0;
    
    [thetstar,fval,exitflag,output] = fminsearch('loss_function_coop',thetstar0,options); % minimize loss functions

    loss_MP_FSP; % solve model
    
    loss_c(nn,1) = loss;
  
    flag_c(nn,1) = exitflag;

    stddev_FSP_MP(nn,:) = 100.*(diag(oo_.var)).^0.5; % compute standard deviations    
    
    parameters_c(nn,:) = [ thetstar ];               % store optmized parameters
        
end;

save intial_conditions_coop.txt initial_values -ASCII -DOUBLE;
save optimized_coeffs_coop.txt  parameters_c   -ASCII -DOUBLE;
save loss_coop.txt              loss_c         -ASCII -DOUBLE;

load optimized_coeffs_coop.txt;
load loss_coop.txt;

[ii,jj]  = min(loss_coop);

thetstar = optimized_coeffs_coop(jj,:);

save coop_optimized.txt thetstar -ASCII -DOUBLE;

loss_MP_FSP;

